#include <PocketFrog.h>

using namespace Frog;

class ButtonTest : public Game
{
public:
  ButtonTest::ButtonTest();
  ButtonTest::~ButtonTest();

  virtual bool GameInit();
  virtual void GameLoop();
  virtual void GameEnd();
  virtual void ButtonDown(int);
  virtual void ButtonUp(int);
  virtual void StylusDown(Point);
  virtual void StylusMove(Point);
  virtual void StylusUp(Point);
};

CComModule _Module;

ButtonTest::ButtonTest()
{
  m_config.szWindowName     = _T("ButtonTest");
  m_config.orientation      = ORIENTATION_NORTH;
  m_config.splashScreenTime = 1000;
}

ButtonTest::~ButtonTest()
{
}

bool ButtonTest::GameInit()
{
  GetDisplay()->Clear(0x0);
  return true;
}

void ButtonTest::GameLoop()
{
  GetDisplay()->Update();
  Sleep(10);
}

void ButtonTest::GameEnd()
{
}

void ButtonTest::ButtonDown(int button)
{
  const InputDevice::KeyList& keys = GetInput()->GetKeyList();

  // Button Test
  if(button == keys.vkUp)    GetDisplay()->DrawRect(110, 100, 130, 140, Frog::Color(255, 255, 255));
  if(button == keys.vkDown)  GetDisplay()->DrawRect(110, 180, 130, 220, Frog::Color(255, 255, 255));
  if(button == keys.vkLeft)  GetDisplay()->DrawRect( 60, 150, 100, 170, Frog::Color(255, 255, 255));
  if(button == keys.vkRight) GetDisplay()->DrawRect(140, 150, 180, 170, Frog::Color(255, 255, 255));
  if(button == keys.vkA)     GetDisplay()->DrawCircle( 36,  36, 20, Frog::Color(255, 255, 255));
  if(button == keys.vkB)     GetDisplay()->DrawCircle( 92,  36, 20, Frog::Color(255, 255, 255));
  if(button == keys.vkC)     GetDisplay()->DrawCircle(148,  36, 20, Frog::Color(255, 255, 255));
  if(button == keys.vkStart) GetDisplay()->DrawCircle(204,  36, 20, Frog::Color(255, 255, 255));
  if(button == keys.vkAux1)  GetDisplay()->DrawCircle( 73, 284, 20, Frog::Color(255, 255, 255));
  if(button == keys.vkAux2)  GetDisplay()->DrawCircle(167, 284, 20, Frog::Color(255, 255, 255));
}

void ButtonTest::ButtonUp(int button)
{
  const InputDevice::KeyList& keys = GetInput()->GetKeyList();

  if(button == keys.vkUp)    GetDisplay()->DrawRect(110, 100, 130, 140, Frog::Color(0x0));
  if(button == keys.vkDown)  GetDisplay()->DrawRect(110, 180, 130, 220, Frog::Color(0x0));
  if(button == keys.vkLeft)  GetDisplay()->DrawRect( 60, 150, 100, 170, Frog::Color(0x0));
  if(button == keys.vkRight) GetDisplay()->DrawRect(140, 150, 180, 170, Frog::Color(0x0));
  if(button == keys.vkA)     GetDisplay()->DrawCircle( 36,  36, 20, Frog::Color(0x0));
  if(button == keys.vkB)     GetDisplay()->DrawCircle( 92,  36, 20, Frog::Color(0x0));
  if(button == keys.vkC)     GetDisplay()->DrawCircle(148,  36, 20, Frog::Color(0x0));
  if(button == keys.vkStart) GetDisplay()->DrawCircle(204,  36, 20, Frog::Color(0x0));
  if(button == keys.vkAux1)  GetDisplay()->DrawCircle( 73, 284, 20, Frog::Color(0x0));
  if(button == keys.vkAux2)  GetDisplay()->DrawCircle(167, 284, 20, Frog::Color(0x0));
}

void ButtonTest::StylusDown(Point p)
{
  Shutdown();
}

void ButtonTest::StylusMove(Point p)
{
}

void ButtonTest::StylusUp(Point p)
{
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE, LPTSTR, int )
{
  ButtonTest *pButtonTest;
  _Module.Init( 0, hInstance );
  pButtonTest = new ButtonTest();
  pButtonTest->Run();
  return 0;
}
